module Main where

import Data.Maybe
import Scanner
import Kombinatoren

data MiniFunkExpr = Let String MiniFunkExpr MiniFunkExpr
     | Plus MiniFunkExpr MiniFunkExpr
     | Const Int
     | Var String
     deriving (Eq, Show)

isVar (VarToken x) = True
isVar _ = False

isSym x (SymToken y) = x == y
isSym _ _ = False

isInt (IntToken n) = True
isInt _ = False

expr :: Parser Token MiniFunkExpr
expr = (texp +.+ expr')  <<< \(e1, e2) -> if (e2 == Nothing) then e1 else Plus e1 (fromJust e2)

expr' :: Parser Token (Maybe MiniFunkExpr)
expr' = 
  (((satisfy (isSym '+')) +.+ texp +.+ expr') 
     <<< (\(_,(e1, e2)) -> if (e2 == Nothing) then Just e1 else Just (Plus e1 (fromJust e2))))
 ||| succeed Nothing
texp :: Parser Token MiniFunkExpr
texp = (((lexem LetToken) +.+ (satisfy isVar) +.+ (satisfy (isSym '=')) +.+ expr +.+ (lexem InToken) +.+ expr)
 <<< (\(_,(VarToken id, (_, (e, (_, e2))))) -> (Let id e e2)))
 ||| ((satisfy isVar) <<< (\(VarToken id) -> Var id))
 ||| ((satisfy isInt) <<< (\(IntToken n) -> Const n))

-- nur wenn keine Tokens brig sind ist die Loesung korrekt
correctsols :: [(t, [a])] -> [(t, [a])]
correctsols sols = (filter (\(_, resttokens) -> null resttokens)) sols

parser :: String -> MiniFunkExpr
parser = fst . head . correctsols. expr . alexScanTokens

main = do
  s <- readFile "/Users/pl/Lehre/Uni_Ausgewaehlte_Themen_PS_CB_INF3189/Kombinatoren/fst.mfe"
  --s <- getContents
  --print ((expr . alexScanTokens) s)
  print s
  print (parser s)
